# Resources for Maintaining the Bot

## Documentation

1. [Discord Py Documentation](https://discordpy.readthedocs.io/en/stable/index.html)

> 1. [Quickstart Guide](https://discordpy.readthedocs.io/en/stable/quickstart.html)
> 2. [Set up of Discord Bot Account](https://discordpy.readthedocs.io/en/stable/discord.html)
> 3. [**Important**: Primer to Gateway Intents](https://discordpy.readthedocs.io/en/stable/intents.html)  
`N.B.: this is an important security feature of Discord that is now mandatory to configure and imposes restructions on some of the Bot's functionality unless appropriately configured. Keep an eye on this.`
> 4. [Repository with example code](https://github.com/Rapptz/discord.py/tree/v1.7.3/examples)
> 5. [Logging Setup](https://discordpy.readthedocs.io/en/stable/logging.html)

2. [Discord Py Slash Command Documentation](https://discord-py-slash-command.readthedocs.io/en/latest/index.html)

> 1. [Discord Py Slash Command Authentication](https://discord-py-slash-command.readthedocs.io/en/latest/quickstart.html)  
`N.B.: this is an important security feature in Discord's API, and commands will not be configured unless the applications.commands scope is configured correctly.`
> 2. [How to add Slash Commands, including sub-commands](https://discord-py-slash-command.readthedocs.io/en/latest/faq.html#:~:text=If%20your%20slash%20commands%20don,commands%20scope%20in%20that%20guild.)
> 3. [Slash Command Cogs Module](https://discord-py-slash-command.readthedocs.io/en/latest/discord_slash.cog_ext.html?highlight=cog#discord_slash.cog_ext.cog_subcommand)
> 4. [Discord Py Slach Commands library Components Documentation](https://discord-py-slash-command.readthedocs.io/en/latest/components.html)

`N.B.: Components are what Discord calls buttons and drop down menus.
There are multiple libraries that offer Components integration, but the Discord Py Slash Command is adequate in doing so, and has the clearest documentation so far.
It's best to stick to one library to keep it consistent.
Avoid the Discord_components library as it causes conflicts with Discord Py Slash Commands.`


## YouTube Tutorials

1. [Starting from the basics by Lucas](https://www.youtube.com/watch?v=nW8c7vT6Hl4)
2. [Introduction to Cogs](https://www.youtube.com/watch?v=vQw8cFfZPx0)
3. [Dynamic prefixes for different servers](https://www.youtube.com/watch?v=yrHbGhem6I4)
4. [Using the new Slash Command API](https://www.youtube.com/watch?v=CLQ8gfb2jh4)

## Communities

### Discord Py

1. [Discord Py server](https://discord.gg/r3sSKJJ): Discord server to talk to others in the community
2. [Discord Py Github issue tracker](https://github.com/Rapptz/discord.py/issues): place to report bugs and issues with the API
3. [Discord Py discussion page](https://github.com/Rapptz/discord.py/discussions): wiki for any other discussions

### Discord Py Slash Commands

1. [Discord Py Slash Commands Discord Server](https://discord.gg/KkgMBVuEkx): Discord server with a forum to ask questions in
2. [Discord Py Slash Commands Issue Tracker on GitHub](https://github.com/discord-py-slash-commands/discord-py-interactions/issues)
